//
// Created by jovian on 18/07/17.
//

#ifndef TINYSHOOTER_GAMECORE_H
#define TINYSHOOTER_GAMECORE_H

// Read hardware commands
#include "Control/InputAndJoy.h"

// For game contents
#include "Physics/TinyWorld.h"

// For game display
#include "Graphics/Renderer.h"

// For creation of entities
#include "Physics/Wall.h"
#include "Physics/HumanSoldier.h"
#include "Physics/AISoldier.h"

class GameCore {
public :
    GameCore();
    virtual ~GameCore();

    bool initialize(); // Create attributes, return false if failure occurred
    void startQuickGame(); // Start a default game

protected:
    InputAndJoy *m_input;
    TinyWorld *m_world;
    Renderer *m_rend;
};


#endif //TINYSHOOTER_GAMECORE_H
