//
// Created by jovian on 31/07/17.
//

#ifndef TINYSHOOTER_B2ANGLE_H
#define TINYSHOOTER_B2ANGLE_H

#include <Box2D/Box2D.h>

/**
 * Give angle between u and v
 * @param u : First vector
 * @param v : Second vector
 * @return Float angle in radians
 */
float b2Angle(const b2Vec2 &u, const b2Vec2 &v);

/**
 * Give angle between u and horizon
 * @param u : Vector
 * @return Float angle in radians
 */
float b2Angle(const b2Vec2 &u);

/**
 * Give a direction from an angle.
 * @param angle Angle of object in radians.
 * @return Unit vector.
 */
b2Vec2 b2Dir(const float angle);

#endif //TINYSHOOTER_B2ANGLE_H
